/**
 * values.js - Get the tints and shades of a color
 * @version v0.1.5
 * @link http://noeldelgado.github.io/Values.js/
 * @license MIT
 */
!function(){"use strict";var t=function(t){this.hex="#000000",this.rgb="rgb(0, 0, 0)",this.rgba="rgba(0, 0, 0, 0)",this.hsl="hsl(0, 0%, 0%)",this.hsla="hsla(0, 0%, 0%, 0)",this.brightness=0,this.step=1,this.tints=[],this.shades=[],this.all=[],this._rgb={r:0,g:0,b:0},this._rgba={r:0,g:0,b:0,a:0},this._hsl={h:0,s:0,l:0},this._hsla={h:0,s:0,l:0,a:0},"string"==typeof t&&this.setColor(t)};t.Utils={_reHEX:new RegExp("^(#)?([0-9a-fA-F]{3})([0-9a-fA-F]{3})?$"),_reRGB:new RegExp("rgba?\\s*\\((\\d+)\\,\\s*(\\d+)\\,\\s*(\\d+)(,\\s*(\\d+(\\.\\d+)?))?\\)","i"),_reHSL:new RegExp("hsla?\\((\\d+),\\s*([\\d.]+)%,\\s*([\\d.]+)%,?\\s*(?:0(\\.\\d+)?|1(\\.0)?)?\\)","i"),isHEX:function(t){return this._reHEX.test(t)},isRGB:function(t){var s,r,e,i,n;return s=!1,this._reRGB.test(t)&&(r=t.match(this._reRGB),e=r[1],i=r[2],n=r[3],255>=e&&255>=i&&255>=n&&(s=!0)),s},isHSL:function(t){var s,r,e,i,n;return s=!1,this._reHSL.test(t)&&(r=t.match(this._reHSL),e=r[1],i=r[2],n=r[3],360>=e&&100>=i&&100>=n&&(s=!0)),s},RGBA:function(t,r){var e=s(t);return"rgba("+e.r+", "+e.g+", "+e.b+", "+r+")"}};var s=function(t){var s,r,e;return t=t.replace("#",""),6===t.length?(s=parseInt(t.slice(0,2),16),r=parseInt(t.slice(2,4),16),e=parseInt(t.slice(4,6),16)):(s=parseInt(t.slice(0,1)+t.slice(0,1),16),r=parseInt(t.slice(1,2)+t.slice(1,2),16),e=parseInt(t.slice(2,3)+t.slice(2,3),16)),{r:s,g:r,b:e}},r=function(t,s,r){return t=parseInt(t).toString(16),s=parseInt(s).toString(16),r=parseInt(r).toString(16),t=1===t.length?"0"+t:t,s=1===s.length?"0"+s:s,r=1===r.length?"0"+r:r,"#"+t+s+r},e=function(t,s,r){var e,i,t=t/255,s=s/255,r=r/255,n=Math.max(t,s,r),h=Math.min(t,s,r),a=(n+h)/2;if(n===h)e=i=0;else{var l=n-h;switch(i=a>.5?l/(2-n-h):l/(n+h),n){case t:e=(s-r)/l+(r>s?6:0);break;case s:e=(r-t)/l+2;break;case r:e=(t-s)/l+4}e/=6}return{h:e,s:i,l:a}},i=function(t,s,r){return 0>r&&(r+=1),r>1&&(r-=1),1>6*r?t+6*(s-t)*r:1>2*r?s:2>3*r?t+(s-t)*(2/3-r)*6:t},n=function(t,s,r){var e,n,h;if(0==s)e=n=h=r;else{var a=.5>r?r*(1+s):r+s-r*s,l=2*r-a;e=i(l,a,t+1/3),n=i(l,a,t),h=i(l,a,t-1/3)}return{r:255*e,g:255*n,b:255*h}},h=function(t){var s=t.r+t.g+t.b;return Math.round(s/765*100)},a=function(t,s,e,i,n){var a=Math.round(s.r),l=Math.round(s.g),o=Math.round(s.b);return t._rgb={r:a,g:l,b:o},t._hsl={h:e,s:i,l:n},t.hex=r(a,l,o),t._rgba=t._rgb.a=1,t._hsla=t._hsl.a=1,t.rgb="rgb("+a+", "+l+", "+o+")",t.rgba="rgba("+a+", "+l+", "+o+", 1)",t.hsl="hsl("+e+", "+i+"%, "+n+"%)",t.hsla="hsla("+e+", "+i+"%, "+n+"%, 1)",t.brightness=h(t._rgb),t};t.prototype.setColor=function(i){var h,l,o,u,g,_,p,c;if(t.Utils.isHEX(i))/^#/.test(i)||(i="#"+i),h=i;else if(t.Utils.isRGB(i))p=i.replace(/[^\d,]/g,"").split(","),h=r(p[0],p[1],p[2]);else{if(!t.Utils.isHSL(i))return console.error(i+" is not a valid color"),null;c=i.match(t.Utils._reHSL),p=n(c[1]/360,c[2]/100,c[3]/100),h=r(p.r,p.g,p.b)}return l=s(h),o=e(l.r,l.g,l.b),u=Math.round(360*o.h),g=Math.round(100*o.s),_=Math.round(100*o.l),a(this,l,u,g,_),this.step=1,this.__updateValues(),this},t.prototype.setStep=function(t){return this.step=t,this.__updateValues(),this},t.prototype.getTints=function(t){var s=this.tints;return t&&(s=s.concat(this.__getCurrent())),s},t.prototype.getShades=function(t){var s=this.shades;return t&&(s=[this.__getCurrent()].concat(s)),s},t.prototype.getAll=function(){return this.all},t.prototype.lightness=function l(t){if("number"==typeof t){var s=this._hsl.h,r=this._hsl.s,e=this._hsl.l,i=e+t;0>i&&(l=0),i>100&&(l=100);var h=n(s/360,r/100,i/100),o=a({},h,s,r,i);return o}console.error("lightness expects a number")},t.prototype.__updateValues=function(){this.tints=this.__getTints(),this.shades=this.__getShades(),this.all=this.tints.concat(this.__getCurrent(),this.shades)},t.prototype.__getCurrent=function(){return a({},this._rgb,this._hsl.h,this._hsl.s,this._hsl.l)},t.prototype.__getTints=function(){for(var t=this._hsl.h,s=this._hsl.s,r=this._hsl.l,e=100,i=[];e>parseInt(r,10);){var h=n(t/360,s/100,e/100);i[i.length]=a({},h,t,s,e),e-=this.step}return i},t.prototype.__getShades=function(){for(var t=this._hsl.h,s=this._hsl.s,r=this._hsl.l,e=0,i=[];e<parseInt(r,10);){var h=n(t/360,s/100,e/100);i[i.length]=a({},h,t,s,e),e+=this.step}return i.reverse()},"undefined"!=typeof module&&"undefined"!=typeof module.exports?module.exports=t:window.Values=t}();